#!/usr/bin/python2.5
# -*- coding: utf-8 -*-

######################################################
# Formmail-ajax.py
# einfacher formmailer mit anbindung per ajax
#
# diese Version ist der kuerzeste Weg fuer ein Form-Mail Script
# deswegen kann es keine Lizenzeinschraenkung geben.
# viel Spass damit.
#
# http://www.nooto.de/python/
#
######################################################

import sys, os

if os.environ.get("REQUEST_METHOD", "") != "POST":
    print "Content-Type: text/html; charset=UTF-8\n\n"
    print "POSTERROR"
    sys.exit()

import cgi, smtplib

#### Config-Bereich

sender = "webmaster@example.com"
recipient = "postmaster@example.com"
subject = "Feedback"

#### Ende Config-Bereich

def entities(s):
    try:
        s = s.decode('utf-8')
    except UnicodeError:
        pass
    result = ""
    for char in s:
        if char == '\n':
            result += "<br>"
        elif char == '>':
            result += "&gt;"
        elif char == '<':
            result += "&lt;"
        elif char == '&':
            result += "&amp;"
        elif char == '"':
            result += "&quot;"
        elif char == "'":
            result += "&apos;"
        elif ord(char) >= 127:
            result += "&#%i" % ord(char)
        else: result += char
    try:
        result = result.encode('utf-8')
    except UnicodeError:
        pass
    return result

formdata = cgi.FieldStorage(keep_blank_values=True)
fields = formdata.keys()

msgtext = ""

for field in fields:
    value = formdata.getvalue(field, "").replace(":", "!")
    msgtext = msgtext + "%s => %s\n" % (field, value)

msg = "Content-Type: text/plain; charset=UTF-8\n"
msg = msg + "From: %s\n" % sender
msg = msg + "To: %s\n" % recipient
msg = msg + "Subject: %s\n\n" % subject
msg = msg + msgtext

mailserver = smtplib.SMTP ("localhost")
mailserver.sendmail(sender, recipient, msg)
mailserver.quit()

msgtext = ""

for field in fields:
    value = entities(formdata.getvalue(field, ""))
    msgtext = msgtext + "%s => %s\n<br>" % (field, value)

print "Content-Type: text/html; charset=UTF-8\n\n"
print "Die Daten wurden erfolgreich verschickt.<br>"
print "Sie haben folgende Daten eingegeben:<br>"
print msgtext
